// fichier : bitwise_operator.cc
// version : 1.0
// 

#include <iostream>

using namespace std;

unsigned int f1(unsigned int n, unsigned int index);
unsigned int f2(unsigned int n, unsigned int index, unsigned int val);
unsigned int f3(unsigned int n, unsigned int width, 
			    unsigned int shift, unsigned int val);


int main(void)
{
	cout << f1(1024,10)  << endl;		// 1
	cout << f1(1024,9)   << endl;		// 0
	cout << f2(1024, 5, 1)  << endl;	// 1056
	cout << f2(31,3,0)  << endl;		// 23
	cout << f3(1024, 2, 4, 3) << endl;	// 1072
	cout << f3(1023, 2, 4, 0) << endl;	// 975
	
	return 0;
}


unsigned int f1(unsigned int n, unsigned int index)
{
	if(index < 32)
	{
		return (n & (1<<index))>> index;
	}
	
	cout << "Index must be within [0, 31] instead of : " << index << endl;
	exit(0);
}

unsigned int f2(unsigned int n, unsigned int index, unsigned int val)
{
	if(index < 32 and val < 2)
	{
		return (n & ~(1<<index)) | (val << index);
	}
	
	cout << "Index must be within [0, 31] and val must be only 0 or 1" << endl;
	exit(0);
}

unsigned int f3(unsigned int n, unsigned int width, 
			    unsigned int shift, unsigned int val)
{
 	if( 1< width and width < 32 and shift < 32-width and val < (1<<width))
	{
		unsigned int mask((1<<width) -1);
		return (n & ~(mask<<shift)) | (val << shift);
	}
	
	cout << "width must be within [1, 32], shift within [0, 32-width]"
	         " and val within [0, 2^width-1]" << endl;
	exit(0);
}

